#!/bin/bash
# (c) Sappien
# version 0.01

# Domoticz server ip+port
domoticz="127.0.0.1:8080"

# Folderpath
folder="/var/bin/ventilatie"

# Domoticz idx of dummy temperature sensors
idxoutsidetemp=20
idxinlet=21
idxreturn=22
idxoutlet=23

# Domoticz idx of dummy on buttons
idxspeed0=19
idxspeed1=15
idxspeed2=16
idxspeed3=17

#################################################

status=`ps ax | grep ventserver.py | grep -v grep`

if [ "$status" == "" ]; then
	echo "Ventserver not running.."
	$folder/ventserver.py > /dev/null 2>&1 &
	sleep 5
else
	echo "Ventserver is running"
fi 


run=`$folder/ventclient.py`

data=$run

buitentemp=`echo $data | cut -d: -f1`
toevoerlucht=`echo $data | cut -d: -f2`
retourlucht=`echo $data | cut -d: -f3`
afvoerlucht=`echo $data | cut -d: -f4`
stand=`echo $data | cut -d: -f7`

# check is needed because sometimes the temperature has a wrong value ( -100 etc)  

check=`echo $toevoerlucht | cut -d. -f1`

if [  "$check" -lt "5" ]
        then
                echo "Wrong data, retry"
		sleep 5
		$folder/status.sh
		exit
        else
                echo "Status WHR"

fi

# Sets the dummy temperature sensors

curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxoutsidetemp&nvalue=0&svalue=$buitentemp"
curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxinlet&nvalue=0&svalue=$toevoerlucht"
curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxreturn&nvalue=0&svalue=$retourlucht"
curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxoutlet&nvalue=0&svalue=$afvoerlucht"

# Check speed and sets corresponding dummy button

if [ "$stand" -eq "0" ] 
	then
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed0&nvalue=1&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed1&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed2&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed3&nvalue=0&svalue="
	fi
	
if [ "$stand" -eq "1" ] 
	then
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed1&nvalue=1&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed0&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed2&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed3&nvalue=0&svalue="
	fi

if [ "$stand" -eq "2" ] 
	then
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed2&nvalue=1&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed0&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed1&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed3&nvalue=0&svalue="
	fi

if [ "$stand" -eq "3" ] 
	then
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed3&nvalue=1&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed0&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed1&nvalue=0&svalue="
		curl -s "http://$domoticz/json.htm?type=command&param=udevice&idx=$idxspeed2&nvalue=0&svalue="
	fi