#!/usr/bin/python
# (c) Shapeshifter @ tweakers.net
import socket, serial, datetime, time

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
sock.bind(('', 111))
sock.listen(1)

while True:
    connection, client_address = sock.accept()
    data = connection.recv(32).strip()
    
    ser = serial.Serial(port = '/dev/YPort', baudrate = 9600, bytesize = serial.EIGHTBITS, parity = serial.PARITY_NONE, stopbits = serial.STOPBITS_ONE)
    
    if data == '?':
        # Obtain temperatures
        response = []
        start = time.time()

        ser.write("\x07\xF0\x00\x0F\x00\xBC\x07\x0F")
        
        while response[-2:] != ['07', '0f'] and time.time() - start < 10:
            response.append(ser.read().encode('hex'))

        if time.time() - start >= 10:
            OutsideAirTemp = -100
            SupplyAirTemp = -100
            ReturnAirTemp = -100
            ExhaustAirTemp = -100
        else:
            OutsideAirTemp = int(response[7], 16) / 2.0 - 20
            SupplyAirTemp = int(response[8], 16) / 2.0 - 20
            ReturnAirTemp = int(response[9], 16) / 2.0 - 20
            ExhaustAirTemp = int(response[10], 16) / 2.0 - 20

        # Obtain fan status
        response = []
        start = time.time()

        ser.write("\x07\xF0\x00\xCD\x00\x7A\x07\x0F")

        while response[-2:] != ['07', '0f'] and time.time() - start < 10:
            response.append(ser.read().encode('hex'))

        if time.time() - start >= 10:
            ReturnAirLevel = -1
            SupplyAirLevel = -1
            FanLevel = -1
        else:
            ReturnAirLevel = int(response[13], 16)
            SupplyAirLevel = int(response[14], 16)
            FanLevel = int(response[15], 16) - 1
        
        # Obtain operating time
        response = []
        start = time.time()

        ser.write("\x07\xF0\x00\xDD\x00\x8A\x07\x0F")

        while response[-2:] != ['07', '0f'] and time.time() - start < 10:
            response.append(ser.read().encode('hex'))

        if time.time() - start >= 10:
            LowTime = -100
            MediumTime = -100
            HighTime = -100
            FilterTime = -100
        else:
            LowTime = int(''.join(response[10:13]), 16)
            MediumTime = int(''.join(response[13:16]), 16)
            HighTime = int(''.join(response[24:27]), 16)
            FilterTime = int(''.join(response[22:24]), 16)

	connection.sendall(str(OutsideAirTemp)+':'+str(SupplyAirTemp)+':'+str(ReturnAirTemp)+':'+str(ExhaustAirTemp)+':'+str(ReturnAirLevel)+':'+str(SupplyAirLevel)+':'+str(FanLevel)+':'+str(LowTime)+':'+str(MediumTime)+':'+str(HighTime)+':'+str(FilterTime))
        
    elif data == '00':
        ser.write("\x07\xF0\x00\x99\x01\x00\x47\x07\x0F")
    elif data == '0':
        ser.write("\x07\xF0\x00\x99\x01\x01\x48\x07\x0F")
    elif data == '1':
        ser.write("\x07\xF0\x00\x99\x01\x02\x49\x07\x0F")
    elif data == '2':
        ser.write("\x07\xF0\x00\x99\x01\x03\x4A\x07\x0F")
    elif data == '3':
        ser.write("\x07\xF0\x00\x99\x01\x04\x4B\x07\x0F")

    ser.close()
    connection.close()
